=== debian/changelog ===
tremotesf (2.4.0-1) unstable; urgency=medium

  * Initial packaging (Closes: #1053805)

 -- Antoine Beaupré <anarcat@debian.org>  Wed, 11 Oct 2023 12:03:24 -0400
