=== debian/control ===
Source: tremotesf
Maintainer: Antoine Beaupré <anarcat@debian.org>
Section: net
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-cmake,
               dh-cmake-compat (= 1),
               dh-sequence-cmake,
               dh-sequence-ctest,
               gettext,
               libcpp-httplib-dev,
               libcxxopts-dev,
               libfmt-dev,
               libkf5widgetsaddons-dev,
               libkf5windowsystem-dev,
               libpsl-dev,
               libssl-dev,
               ninja-build,
               pkgconf,
               qtbase5-dev,
               qttools5-dev,
Standards-Version: 4.6.2
Homepage: https://github.com/equeim/tremotesf2

Package: tremotesf
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Suggests: transmission-daemon,
Description: Remote GUI for transmission-daemon
 Tremotesf is yet another, but modern (first-released in 2016)
 cross-platfom GUI for Transmission daemon written in C++ and Qt.
 .
 Features include, but not necessarily limited to:
  * View torrent list
  * Sort torrents
  * Filter torrents by name, status and trackers
  * Start/stop/verify/remove torrents with multi-selection
  * Add torrents from torrent files and magnet links
  * Select which files to download when adding torrent
  * Manage torrent files
  * Add and remove torrent trackers
  * View torrent peers
  * Set torrent limits
  * Change remote server settings
  * View server statistics
  * Multiple servers
  * Supports HTTPS connection
  * Can connect to servers with self-signed certificates (you need to add
    certificate to server settings)
  * Client certificate authentication
